Rem example of a keymapper. v1.0a QB64 PD 2025.
Rem $Dynamic
Const True = -1
Const False = 0
Const Version = "v1.0a"
DefLng A-Z
_ScreenMove _Middle
_Title "Keymapper " + Version
On Error GoTo Hell
' start timer trap.
On Timer(1) Timer.Trap
Timer On
VarQ = _Exit
Color 12
Print "Starting Keymapper " + Version + ":"
' dimension array subscript 1 equals:
'   1 is:
'     0 = no point.
'     1 = point to 2
'     2 = point to 3.
'   2 = ascii map.
'   3 = extended map.
Dim Shared KeyMap(3, 0 To 255) As Integer ' ascii
Dim Shared KeyMapExtended(3, 0 To 255) As Integer ' extended ascii
Dim Shared ControlBreak As Integer
' main loop.
Do
   Call Edit.Status.Line
   ' start loop.
   Do
      Color 15
      Print "Menu Select"
      Color 14
      Print " (1)Enter Mapper"
      Print " (2)Ascii Chart"
      Print " (3)Clear Keys"
      Print " (4)List Ascii Keymap table"
      Print " (5)List Extended Keymap table"
      Print " (6)Quit"
      Color 15
      Print "Enter Option?";
      Do
         _Limit 50
         Inpt$ = InKey$
         If ControlBreak Then Color 7: End
         If Len(Inpt$) Then
            If Inpt$ = Chr$(3) Then
               ' nul
            Else
               Entry = Int(Val(Inpt$))
               Exit Do
            End If
         End If
      Loop
      Print
      If Entry = 1 Then Exit Do
      If Entry = 2 Then Call DisplayChart
      If Entry = 3 Then
         For x = 1 To 3
            For y = 0 To 255
               KeyMap(x, y) = 0
               KeyMapExtended(x, y) = 0
            Next
         Next
         Color 14
         Print "Key Map arrays reset."
      End If
      If Entry = 4 Then
         Call ListChart
         Call ListChart2
      End If
      If Entry = 5 Then
         Call ListChart3
         Call ListChart4
      End If
      If Entry = 6 Then
         Call End.Program
         Color 7
         End
      End If
   Loop
   ' mapper loop.
   Do
      Color 15
      Print "Select From Option"
      Color 14
      Print " (1)Ascii KeyScan"
      Print " (2)Extended KeyScan"
      Print " (3)Continue to Keytest"
      Color 15
      Print "Enter Option?";
      Do
         _Limit 50
         Inpt$ = InKey$
         If ControlBreak Then Color 7: End
         If Len(Inpt$) Then
            If Inpt$ = Chr$(3) Then
               ' nul
            Else
               KeyType1 = Int(Val(Inpt$))
               Exit Do
            End If
         End If
      Loop
      Print
      If KeyType1 = 3 Then Exit Do
      Color 15
      Print "Select To Option"
      Color 14
      Print " (1)Ascii KeyScan"
      Print " (2)Extended KeyScan"
      Print " (3)Continue to Keytest"
      Color 15
      Print "Enter Option?";
      Do
         _Limit 50
         Inpt$ = InKey$
         If ControlBreak Then Color 7: End
         If Len(Inpt$) Then
            If Inpt$ = Chr$(3) Then
               ' nul
            Else
               KeyType2 = Int(Val(Inpt$))
               Exit Do
            End If
         End If
      Loop
      Print
      If KeyType2 = 3 Then Exit Do
      If (KeyType1 = 1 Or KeyType1 = 2) And (KeyType2 = 1 Or KeyType2 = 2) Then
         If KeyType1 = 1 Then
            Color 14
            Print "Enter ascii key scan code to map(1-255)?";
            Scan.From = Int(Val(LineInput$(CsrLin, Pos(0), 10))): Print
         End If
         If KeyType1 = 2 Then
            Color 14
            Print "Enter extended key scan code to map(1-255)?";
            Scan$ = LineInput$(CsrLin, Pos(0), 20): Print
            Scan.From = GetExtendedKey(Scan$)
         End If
         If KeyType2 = 1 Then
            Color 14
            Print "Enter target ascii key scan code(0-255)?";
            Scan.To = Int(Val(LineInput$(CsrLin, Pos(0), 10))): Print
         End If
         If KeyType2 = 2 Then
            Color 14
            Print "Enter target extended key scan code(0-255)?";
            Scan$ = LineInput$(CsrLin, Pos(0), 20): Print
            Scan.To = GetExtendedKey(Scan$)
         End If

         If Scan.From >= 1 And Scan.From <= 255 Then
            If Scan.To = 0 Then
               If KeyType1 = 1 Then
                  KeyMap(1, Scan.From) = 0
               End If
               If KeyType1 = 2 Then
                  KeyMapExtended(1, Scan.From) = 0
               End If
               Color 15
               Print "Key cleared."
            End If
            If Scan.To >= 1 And Scan.To <= 255 Then
               If KeyType1 = 1 Then
                  If KeyType2 = 1 Then
                     KeyMap(1, Scan.From) = 1
                     KeyMap(2, Scan.From) = Scan.To
                  Else
                     KeyMap(1, Scan.From) = 2
                     KeyMap(3, Scan.From) = Scan.To
                  End If
                  Color 15
                  Print "Ascii key set."
               End If
               If KeyType1 = 2 Then
                  If KeyType2 = 1 Then
                     KeyMapExtended(1, Scan.From) = 1
                     KeyMapExtended(2, Scan.From) = Scan.To
                  Else
                     KeyMapExtended(1, Scan.From) = 2
                     KeyMapExtended(3, Scan.From) = Scan.To
                  End If
                  Color 15
                  Print "Extended key set."
               End If
            End If
         End If
      End If
   Loop
   ' test mapper loop.
   Color 15
   Print "Try key(<esc> to exit).."
   Color 14
   Do
      x$ = INKEYx$
      If x$ = Chr$(27) Then Exit Do
      ' map ascii code.
      If Len(x$) = 1 Then
         y = Asc(x$)
         If KeyMap(1, y) = 0 Then
            _ControlChr Off
            Print "From: "; x$; " to: "; Chr$(y)
            _ControlChr On
         End If
         If KeyMap(1, y) = 1 Then
            z = KeyMap(2, y)
            _ControlChr Off
            Print "From: "; x$; " to: "; Chr$(z)
            _ControlChr On
         End If
         If KeyMap(1, y) = 2 Then
            z = KeyMap(3, y)
            Print "From: "; x$; " to: 0:"; LTrim$(Str$(z))
         End If
      End If
      ' map extended code.
      If Len(x$) = 2 Then
         y = Asc(Right$(x$, 1))
         If KeyMapExtended(1, y) = 0 Then
            _ControlChr Off
            Print "From:"; y; "to: 0:"; LTrim$(Str$(y))
            _ControlChr On
         End If
         If KeyMapExtended(1, y) = 1 Then
            z = KeyMapExtended(2, y)
            _ControlChr Off
            Print "From:"; y; "to: "; Chr$(z)
            _ControlChr On
         End If
         If KeyMapExtended(1, y) = 2 Then
            z = KeyMapExtended(3, y)
            Print "From:"; y; "to: 0:"; LTrim$(Str$(z))
         End If
      End If
   Loop
Loop
Call End.Program
Color 7
End

Hell:
Color 10
Print "Critical error"; Err; " IDE"; _ErrorLine
Call Clear.Status.Line
Color 7
End

Function GetExtendedKey (x$)
   If Int(Val(x$)) >= 1 And Int(Val(x$)) <= 255 Then
      GetExtendedKey = Int(Val(x$))
      Exit Function
   End If
   z$ = UCase$(x$)
   Select Case z$
      Case "UP"
         x = 72
      Case "CTRL-UP"
         x = 141
      Case "ALT-UP"
         x = 152
      Case "DOWN"
         x = 80
      Case "CTRL-DOWN"
         x = 145
      Case "ALT-DOWN"
         x = 160
      Case "LEFT"
         x = 75
      Case "CTRL-LEFT"
         x = 115
      Case "ALT-LEFT"
         x = 155
      Case "RIGHT"
         x = 77
      Case "CTRL-RIGHT"
         x = 116
      Case "ALT-RIGHT"
         x = 157
      Case "KEYPAD-5"
         x = 76
      Case "SHIFT-KEYPAD-5"
         x = 53
      Case "CTRL-KEYPAD-5"
         x = 143
      Case "ALT-KEYPAD-5"
         x = 5
      Case "PAGEUP"
         x = 73
      Case "SHIFT-PAGEUP"
         x = 57
      Case "CTRL-PAGEUP"
         x = 132
      Case "ALT-PAGEUP"
         x = 9
      Case "PAGEDOWN"
         x = 81
      Case "SHIFT-PAGEDOWN"
         x = 51
      Case "CTRL-PAGEDOWN"
         x = 118
      Case "ALT-PAGEDOWN"
         x = 3
      Case "HOME"
         x = 71
      Case "SHIFT-HOME"
         x = 55
      Case "CTRL-HOME"
         x = 119
      Case "ALT-HOME"
         x = 7
      Case "END"
         x = 79
      Case "SHIFT-END"
         x = 49
      Case "CTRL-END"
         x = 117
      Case "ALT-END"
         x = 1
      Case "INSERT"
         x = 82
      Case "SHIFT-INSERT"
         x = 48
      Case "CTRL-INSERT"
         x = 146
      Case "ALT-INSERT"
      Case "DELETE"
         x = 83
      Case "SHIFT-DELETE"
         x = 46
      Case "CTRL-DELETE"
         x = 147
      Case "ALT-DELETE"
      Case "F1"
         x = 59
      Case "F2"
         x = 60
      Case "F3"
         x = 61
      Case "F4"
         x = 62
      Case "F5"
         x = 63
      Case "F6"
         x = 64
      Case "F7"
         x = 65
      Case "F8"
         x = 66
      Case "F9"
         x = 67
      Case "F10"
         x = 68
      Case "SHIFT-F1"
         x = 84
      Case "SHIFT-F2"
         x = 85
      Case "SHIFT-F3"
         x = 86
      Case "SHIFT-F4"
         x = 87
      Case "SHIFT-F5"
         x = 88
      Case "SHIFT-F6"
         x = 89
      Case "SHIFT-F7"
         x = 90
      Case "SHIFT-F8"
         x = 91
      Case "SHIFT-F9"
         x = 92
      Case "SHIFT-F10"
         x = 93
      Case "CTRL-F1"
         x = 94
      Case "CTRL-F2"
         x = 95
      Case "CTRL-F3"
         x = 96
      Case "CTRL-F4"
         x = 97
      Case "CTRL-F5"
         x = 98
      Case "CTRL-F6"
         x = 99
      Case "CTRL-F7"
         x = 100
      Case "CTRL-F8"
         x = 101
      Case "CTRL-F9"
         x = 102
      Case "CTRL-F10"
         x = 103
      Case "ALT-F1"
         x = 104
      Case "ALT-F2"
         x = 105
      Case "ALT-F3"
         x = 106
      Case "ALT-F4"
         x = 107
      Case "ALT-F5"
         x = 108
      Case "ALT-F6"
         x = 109
      Case "ALT-F7"
         x = 110
      Case "ALT-F8"
         x = 111
      Case "ALT-F9"
         x = 112
      Case "ALT-F10"
         x = 113
      Case "F11"
         x = 133
      Case "SHIFT-F11"
         x = 135
      Case "CTRL-F11"
         x = 137
      Case "ALT-F11"
         x = 139
      Case "F12"
         x = 134
      Case "SHIFT-F12"
         x = 136
      Case "CTRL-F12"
         x = 138
      Case "ALT-F12"
         x = 140
      Case "ALT-1"
         x = 120
      Case "ALT-2"
         x = 121
      Case "ALT-3"
         x = 122
      Case "ALT-4"
         x = 123
      Case "ALT-5"
         x = 124
      Case "ALT-6"
         x = 125
      Case "ALT-7"
         x = 126
      Case "ALT-8"
         x = 127
      Case "ALT-9"
         x = 128
      Case "ALT-0"
         x = 129
      Case "ALT--"
         x = 130
      Case "ALT-="
         x = 131
      Case "ALT-A"
         x = 30
      Case "ALT-B"
         x = 48
      Case "ALT-C"
         x = 46
      Case "ALT-D"
         x = 32
      Case "ALT-E"
         x = 18
      Case "ALT-F"
         x = 33
      Case "ALT-G"
         x = 34
      Case "ALT-H"
         x = 35
      Case "ALT-I"
         x = 23
      Case "ALT-J"
         x = 36
      Case "ALT-K"
         x = 37
      Case "ALT-L"
         x = 38
      Case "ALT-M"
         x = 50
      Case "ALT-N"
         x = 49
      Case "ALT-O"
         x = 24
      Case "ALT-P"
         x = 25
      Case "ALT-Q"
         x = 16
      Case "ALT-R"
         x = 19
      Case "ALT-S"
         x = 31
      Case "ALT-T"
         x = 20
      Case "ALT-U"
         x = 22
      Case "ALT-V"
         x = 47
      Case "ALT-W"
         x = 17
      Case "ALT-X"
         x = 45
      Case "ALT-Y"
         x = 21
      Case "ALT-Z"
         x = 44
   End Select
   GetExtendedKey = x
End Function

' custom Inkey$ function.
Function INKEYx$
   _Limit 100
   X = _KeyHit
   If X < 0 Then
      Select Case X
         Case -12 ' keypad-5
            INKEYx$ = Chr$(0) + Chr$(76)
            Exit Function
         Case -108 ' ctrl-keypad-5
            INKEYx$ = Chr$(0) + Chr$(143)
            Exit Function
      End Select
   End If
   X$ = InKey$
   If Len(X$) Then
      INKEYx$ = X$
   End If
End Function

' routine to display ascii chart.
Sub DisplayChart
   Cls
   Color 15
   Locate 2, 2, 0
   Print "ASCII Chart for characters 1 to 127:"
   Var2 = 3
   Locate 3, 2, 0
   For Char = 1 To 127
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14
      _ControlChr Off
      Print Chr$(Char) + " ";
      _ControlChr On
      ' check full screen line
      If (Char Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 15
   Locate 2, 2, 0
   Print "ASCII Chart for characters 128 to 255:";
   Var2 = 3
   Locate 3, 2, 0
   For Char = 128 To 255
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14
      Print Chr$(Char) + " ";
      ' check full screen line
      If ((Char - 7) Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 7
End Sub

Sub Edit.Status.Line
   Var$ = "Key Mapper " + Version
   Var$ = Left$(Var$, 79)
   Var$ = Var$ + Space$(79 - Len(Var$))
   Call Display.Status.LineX(True, Var$)
End Sub

Sub Clear.Status.Line
   Var$ = Space$(79)
   Call Display.Status.LineX(False, Var$)
End Sub

Sub Display.Status.LineX (Var, Var$)
   X = CsrLin
   Y = Pos(0)
   If Var Then
      Color 14, 1
   Else
      Color 15, 0
   End If
   Locate 25, 1, 0
   Print Var$;
   If Var Then
      Color 0, 1
   Else
      Color 7, 0
   End If
   Locate 25, 80
   Print " ";
   Locate X, Y, 1
   Color 15, 0
End Sub

' timer ctrl-break trap.
Sub Timer.Trap
   VarQ = _Exit
   If VarQ Then ' Control-Break
      ControlBreak = -1
      Call End.Program
   End If
End Sub

Sub End.Program
   Call Clear.Status.Line
   Timer Off
   Color 7, 0
   System
End Sub

' Custom line input function.
' Input:
'    XC = X-coordinate
'    YC = Y-coordinate
'    LC = Edit area length
Function LineInput$ (XC, YC, LC)
   ' init entry area position.
   Xposition1 = 1
   Xposition2 = 0

   ' display edit entry area.
   Insert = -1
   GoSub DisplayFileLine

   ' main input loop.
   Color 15
   Do
      ' get keypress.
      I$ = INKEYx$

      ' check key.
      If Len(I$) = 1 Then

         ' enter key.
         If I$ = Chr$(13) Then
            LineInput$ = X$
            Exit Do
         End If

         ' escape key.
         If I$ = Chr$(27) Then
            LineInput$ = ""
            Exit Do
         End If

         ' backspace.
         If I$ = Chr$(8) Then
            If Len(X$) Then
               If Xposition2 > 0 Then
                  If Insert Then ' destructive backspace
                     X$ = Left$(X$, Xposition2 - 1) + Mid$(X$, Xposition2 + 1)
                  End If
                  Xposition2 = Xposition2 - 1
                  If Xposition2 - LC <= Xposition1 Then
                     Xposition1 = Xposition1 - 1
                     If Xposition1 < 1 Then
                        Xposition1 = 1
                     End If
                  End If
                  GoSub DisplayFileLine
               End If
            End If
         Else
            ' append/insert character into edit area.
            OK = -1
            If Asc(I$) >= 0 And Asc(I$) <= 31 Then
               OK = 0 ' disallow control charcters
            End If
            If OK Then
               If Insert Then
                  X$ = Left$(X$, Xposition2) + I$ + Mid$(X$, Xposition2 + 1)
                  Xposition2 = Xposition2 + 1
                  If Xposition2 > LC Then
                     Xposition1 = Xposition1 + 1
                  End If
               Else
                  If Xposition2 + 1 > Len(X$) Then
                     X$ = X$ + I$ ' append
                     Xposition2 = Xposition2 + 1
                     If Xposition2 > LC Then
                        Xposition1 = Xposition1 + 1
                     End If
                  Else ' insert
                     Mid$(X$, Xposition2 + 1, 1) = I$
                     Xposition2 = Xposition2 + 1
                  End If
               End If
               GoSub DisplayFileLine
            End If
         End If
      End If

      ' check extended key
      If Len(I$) = 2 Then
         Select Case Asc(Right$(I$, 1))
            Case 82 ' Insert
               Insert = Not Insert
               If Insert Then
                  Locate , , 1, 8, 8 ' line cursor
               Else
                  Locate , , 1, 0, 8 ' block cursor
               End If
            Case 83 ' Delete
               If Len(X$) > 0 Then
                  X$ = Left$(X$, Xposition2) + Mid$(X$, Xposition2 + 2)
                  GoSub DisplayFileLine
               End If
            Case 71, 73, 119 ' Home/PageUp/Ctrl-Home
               If Xposition2 > 0 Then
                  Xposition1 = 1
                  Xposition2 = 0
                  GoSub DisplayFileLine
               End If
            Case 79, 81, 117 ' End/PageDown/Ctrl-End
               If Xposition2 < Len(X$) Then
                  Xposition2 = Len(X$)
                  Xposition1 = Xposition2 - LC + 1
                  If Xposition1 < 1 Then
                     Xposition1 = 1
                  End If
                  GoSub DisplayFileLine
               End If
            Case 75, 115, 155 ' Left/Ctrl-Left/Alt-Left
               If Len(X$) Then
                  If Xposition2 > 0 Then
                     Xposition2 = Xposition2 - 1
                     If Xposition2 - LC <= Xposition1 Then
                        Xposition1 = Xposition1 - 1
                        If Xposition1 < 1 Then
                           Xposition1 = 1
                        End If
                        GoSub DisplayFileLine
                     End If
                  End If
               End If
            Case 77, 116, 157 ' Right/Ctrl-Right/Alt-Right
               If Len(X$) Then
                  If Xposition2 < Len(X$) Then
                     Xposition2 = Xposition2 + 1
                     If Xposition2 > Xposition1 + LC - 1 Then
                        Xposition1 = Xposition1 + 1
                     End If
                     GoSub DisplayFileLine
                  End If
               End If
         End Select
      End If
   Loop
   Locate , , 1, 8, 8 ' line cursor
   Exit Function

   ' display current entry area.
   DisplayFileLine:
   Locate XC, YC, 1
   Print Space$(LC);
   ' display edit line and position cursor.
   Locate XC, YC, 1
   If Len(X$) Then
      Color 15
      Print Mid$(X$, Xposition1, LC);
   End If
   Locate XC, YC + Xposition2 - Xposition1 + 1, 1
   Color 7, 0
   Return
End Function

' routine to display ascii-ascii chart.
Sub ListChart
   Cls
   Color 15
   Locate 2, 2, 0
   Print "ASCII - ASCII Chart for characters 1 to 127:"
   Var2 = 3
   Locate 3, 2, 0
   For Char = 1 To 127
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMap(1, Char) = 1 Then ' ascii
         Color 12
         KeyType = KeyMap(2, Char) ' scanto
      End If

      Var$ = Mid$(Str$(KeyType), 2)
      Var1$ = Right$("000" + Var$, 3)
      Print Var1$;
      If Char < 127 Then Print " ";

      ' check full screen line
      If (Char Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 15
   Locate 2, 2, 0
   Print "ASCII - ASCII Chart for characters 128 to 255:";
   Var2 = 3
   Locate 3, 2, 0
   For Char = 128 To 255
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMap(1, Char) = 1 Then ' ascii
         Color 12
         KeyType = KeyMap(2, Char) ' scanto
      End If

      Print LTrim$(Str$(KeyType));
      If Char < 255 Then Print " ";
      ' check full screen line
      If ((Char - 7) Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 7
End Sub

' routine to display ascii-extended chart.
Sub ListChart2
   Cls
   Color 15
   Locate 2, 2, 0
   Print "ASCII - EXTENDED Chart for characters 1 to 127:"
   Var2 = 3
   Locate 3, 2, 0
   For Char = 1 To 127
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMap(1, Char) = 2 Then ' ascii extended
         Color 12
         KeyType = KeyMap(3, Char) ' scanto
      End If

      Var$ = Mid$(Str$(KeyType), 2)
      Var1$ = Right$("000" + Var$, 3)
      Print Var1$;
      If Char < 127 Then Print " ";

      ' check full screen line
      If (Char Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 15
   Locate 2, 2, 0
   Print "ASCII - EXTENDED Chart for characters 128 to 255:";
   Var2 = 3
   Locate 3, 2, 0
   For Char = 128 To 255
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMap(1, Char) = 2 Then ' ascii extended
         Color 12
         KeyType = KeyMap(3, Char) ' scanto
      End If

      Print LTrim$(Str$(KeyType));
      If Char < 255 Then Print " ";

      ' check full screen line
      If ((Char - 7) Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 7
End Sub

' routine to display extended-ascii chart.
Sub ListChart3
   Cls
   Color 15
   Locate 2, 2, 0
   Print "EXTENDED - ASCII Chart for characters 1 to 127:"
   Var2 = 3
   Locate 3, 2, 0
   For Char = 1 To 127
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMapExtended(1, Char) = 1 Then ' ascii
         Color 12
         KeyType = KeyMapExtended(2, Char) ' scanto
      End If

      Var$ = Mid$(Str$(KeyType), 2)
      Var1$ = Right$("000" + Var$, 3)
      Print Var1$;
      If Char < 127 Then Print " ";

      ' check full screen line
      If (Char Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 15
   Locate 2, 2, 0
   Print "EXTENDED - ASCII Chart for characters 128 to 255:";
   Var2 = 3
   Locate 3, 2, 0
   For Char = 128 To 255
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMapExtended(1, Char) = 1 Then ' ascii
         Color 12
         KeyType = KeyMapExtended(2, Char) ' scanto
      End If

      Print LTrim$(Str$(KeyType));
      If Char < 255 Then Print " ";

      ' check full screen line
      If ((Char - 7) Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 7
End Sub

' routine to display extended-extended chart.
Sub ListChart4
   Cls
   Color 15
   Locate 2, 2, 0
   Print "EXTENDED - EXTENDED Chart for characters 1 to 127:"
   Var2 = 3
   Locate 3, 2, 0
   For Char = 1 To 127
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMapExtended(1, Char) = 2 Then ' ascii extended
         Color 12
         KeyType = KeyMapExtended(3, Char) ' scanto
      End If

      Var$ = Mid$(Str$(KeyType), 2)
      Var1$ = Right$("000" + Var$, 3)
      Print Var1$;
      If Char < 127 Then Print " ";

      ' check full screen line
      If (Char Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 15
   Locate 2, 2, 0
   Print "EXTENDED - EXTENDED Chart for characters 128 to 255:";
   Var2 = 3
   Locate 3, 2, 0
   For Char = 128 To 255
      Var$ = Mid$(Str$(Char), 2)
      Var1$ = Right$("000" + Var$, 3) + " "
      Color 10
      Print Var1$;
      Color 14

      KeyType = Char
      If KeyMapExtended(1, Char) = 2 Then ' ascii extended
         Color 12
         KeyType = KeyMapExtended(3, Char) ' scanto
      End If

      Print LTrim$(Str$(KeyType));
      If Char < 255 Then Print " ";

      ' check full screen line
      If ((Char - 7) Mod 10) = False Then
         Var2 = Var2 + 1
         Locate Var2, 2, 0
      End If
   Next
   Color 15
   Locate 16, 2, 0
   Print "Press key:"
   Do
      _Limit 50
      If InKey$ <> "" Then Exit Do
   Loop
   Color 7
End Sub


